! Xy plot from comma or tab delimited files 
! 
INCLUDE "csvplotlib.bas"
INCLUDE "Choosecsv.bas"
INCLUDE "calcdate.bas"




FN.DEF drawgraph(x[], y[], xname$, yname$,xdate) 
 ! drawgraph:
 ARRAY.LENGTH n, x[]
 IF n<2 
  POPUP "need at least 2 points to make graph", 0,0,0
  GOTO quitgraph
 ENDIF
 GR.OPEN 255,255,255,255
 GR.ORIENTATION 0
 GR.SCREEN acwidth, acheight
 ARRAY.MIN xmin, x[]
 ARRAY.MAX xmax, x[]
 ARRAY.MIN ymin, y[]
 ARRAY.MAX ymax, y[]
 ARRAY.AVERAGE xavg, x[]
 ARRAY.AVERAGE yavg, y[]

 xxbar=0
 Yybar=0
 xybar=0
 FOR i=1 TO n
  xybar+=(x[i] * y[i]) 
  xxbar+= (x[i] * x[i])
  Yybar+= (y[i] * y[i])
 NEXT i
 xybar=xybar/n
 xxbar=xxbar/n
 Yybar=yybar/n
 slope=(xybar-xavg*yavg) /(xxbar-xavg*xavg)
 intercept=yavg-slope*xavg
 Rr=(xybar-xavg*yavg) / SQR((xxbar-xavg*xavg)* (yybar-yavg*yavg) )
 Rr=rr*rr

 diwidth=(xmax-xmin)
 diheight=(ymax-ymin)
 ! gr.scale acwidth/diwidth,acheight/diheight
 Sx=acwidth/diwidth
 Sy=acheight /diheight

 GR.SET.STROKE 1

 ytics = 10^FLOOR(LOG10(ABS(ymax-ymin)/10))
 IF (ymax-ymin)/ytics > 10 
  ytics=ytics*10
 ENDIF
 IF (ymax-ymin)/ytics < 5
  ytics=ytics/5
 ENDIF
 Yline1=FLOOR(ymin/ytics)*ytics
 Yline2=CEIL(ymax/ytics)*ytics


 GR.TEXT.SIZE 15
 GR.SET.STROKE 1

 GR.TEXT.ALIGN 1
 py=FLOOR(LOG10(ABS(ytics)))
 FOR y=yline1 TO yline2 STEP ytics
  GR.COLOR 50,0,0,0,1
  Newx= (xmax-xmin)*sx
  Newy= (ymax - y) *sy
  GR.LINE yyy,1, newy, newx, newy 
  GR.COLOR 50,0,80,0,1

  GR.TEXT.DRAW txt3,1,newy-3,Frm$(y,py)
 NEXT y

 xtics = 10^FLOOR(LOG10(ABS(xmax-xmin)/10))
 IF (xmax-xmin)/xtics > 10 
  xtics=xtics*10
 ENDIF
 IF (xmax-xmin)/xtics < 5
  xtics=xtics/5
 ENDIF
 xline1=FLOOR(xmin/xtics)*xtics
 xline2=CEIL(xmax/xtics)*xtics

 px=FLOOR(LOG10(ABS(xtics)))
 GR.TEXT.ALIGN 3
 FOR x=xline1 TO xline2 STEP xtics
  GR.COLOR 50,0,0,0,1
  Newx= (x-xmin)*sx
  Newy= (ymax - ymin) *sy

  IF !xdate
   GR.TEXT.DRAW txt3,newx,newy,Frm$(x,px)
  ELSE
   g$=julianToGregorian$(x)
   GR.TEXT.DRAW txt3,newx,newy,g$
  ENDIF

  GR.LINE xxx,newx, 1, newx, newy 
 NEXT x


 GR.SET.STROKE 5


 Oldx=(x[1] - xmin) *sx
 Oldy= (ymax - y[1])*sy

 FOR i=1 TO n
  LET Newx= (x[i]-xmin)*sx
  LET Newy= (ymax - y[i]) *sy
  GR.COLOR 255,255,0,0,1
  ! GR.line lol,oldx, oldy, newx, newy 
  GR.POINT p, newx, newy
  ! let Oldx=newx
  ! let Oldy=newy
 NEXT i
 GR.COLOR 80,0,255, 0,1

 X1=xmin
 Y1= slope*x1+intercept
 Xn =xmax
 Yn =slope*xn+intercept
 GR.LINE fl, (x1-xmin)*sx,sy*(ymax-y1) , sx*(xn-xmin) ,sy*(ymax- yn)
 GR.TEXT.SIZE 25
 GR.COLOR 100, 0,0, 0,1
 GR.SET.STROKE 1

 GR.TEXT.ALIGN 3

 GR.TEXT.DRAW txt3,acwidth*0.9,acheight*0.1,Frm$(slope,-2)+" slope"
 GR.COLOR 100, 0, 0, 0,1
 GR.TEXT.ALIGN 2
 GR.TEXT.DRAW txt2,acwidth*0.5,acheight*0. 95,  xname$
 GR.ROTATE.START -90, acwidth*0.1,acheight*0.5
 GR.TEXT.DRAW txt2,acwidth*0.1,acheight*0.5, yname$
 GR.ROTATE.END
 GR.RENDER

 ARRAY.AVERAGE xavg, x[]
 ARRAY.STD_DEV xsd,x[]
 ARRAY.MIN xmin, x[]
 ARRAY.MAX xmax, x[]
 ARRAY.AVERAGE yavg, y[]
 ARRAY.STD_DEV ysd,y[]
 ARRAY.MIN ymin, y[]
 ARRAY.MAX ymax, y[]
 Cr$=CHR$(10)
 px=-2
 py=-2
 Msg$= "n = "+ INT$(n) 
 Msg$ += " x:"+xname$
 msg$ += " y:"+yname$+cr$
 msg$ += "xAverage = "+frm$(xavg,px) +cr$+ "xStandard Deviation = "+frm$( xsd,px) +cr$ +"xMin = "+frm$(xmin,px) +cr$+"xMax = "+frm$( xmax,px) +cr$ 
 msg$ += "yAverage = "+frm$( yavg,py) +cr$+ "yStandard Deviation = "+ frm$(ysd,py) +cr$ +"yMin = "+frm$( ymin,py) +cr$ +"yMax = "+frm$( ymax,py) +cr$
 msg$ += "slope=" +frm$(slope,-2)+cr$
 msg$+= "intercept="+frm$(intercept,py)+cr$
 msg$+= "r*r="+frm$(rr,-2)+cr$
 DO
  GR.TOUCH touched, xx,yy
 UNTIL touched

 DIALOG.MESSAGE , msg$ , c, "okay"

 GR.CLOSE
 Quitgraph:
FN.END


dinit()


DO

 A$= chooseFile$("../../")

 IF a$="" THEN EXIT

 IF RIGHT$(a$, 4)<>".csv"& RIGHT$(a$, 4)<>".txt" THEN
  DIALOG.MESSAGE ,"must be .Txt or.Csv ", b, "try again", "quit"
 ENDIF
 IF b=2 THEN END

UNTIL RIGHT$(a$, 4)=".csv"| RIGHT$(a$, 4)=".txt"

Another:

DIALOG.MESSAGE ,"Does CSV file have headers?", choice, "yes", "no"

IF choice=1 
 hasheaders=1
ELSE
 hasheaders=0
ENDIF

TEXT.OPEN R, FN2, a$
Fieldnum=2
LIST.CREATE N,num
TEXT.READLN FN2, a_line$


Delimiter$=""

IF IS_IN(",",a_line$) >0
 Delimiter$=","
 POPUP "comma delimited",0,0,0
ENDIF

IF IS_IN(CHR$(9),a_line$) >0
 Delimiter$=CHR$(9)
 POPUP "tab delimited",0,0,0
ENDIF

IF delimiter$<>"" 
 LIST.CREATE s, flist
 I=0
 DO
  I++

  Ff$= WORD$(a_line$,i ,delimiter$)
  IF hasheaders=0
   f$= "field "+INT$(i)
  ELSE 
   f$=ff$
  ENDIF
  IF ff$<>"" THEN LIST.ADD flist,f$

 UNTIL ff$=""
ENDIF

UNDIM fields$[]
LIST.TOARRAY flist, fields$[]
Msg$="select x"
DIALOG.SELECT xfield, fields$[], msg$
Msg$="select y"
DIALOG.SELECT yfield, fields$[], msg$


LIST.CREATE n,xx
LIST.CREATE n,yy
xdate=0
k=0
n=0
DO
 k++
 IF hasheaders | k > 1
  TEXT.READLN FN2, a_line$
 ENDIF
 IF a_line$ <>"EOF" & a_line$ <> ""
  n++
  d$=WORD$(a_line$, xfield,delimiter$)
  IF !xdate & n=1
   IF isdate(d$) THEN xdate=1
  ENDIF

  x=calcdate(d$)


  y$=WORD$(a_line$,yfield,delimiter$)
  y$=REPLACE$(y$,CHR$(0),"")
  IF y$<>""
   LIST.ADD xx,x
   LIST.ADD yy,VAL(y$)
  ENDIF
 ENDIF
UNTIL a_line$ = "EOF"
TEXT.CLOSE FN2

LIST.TOARRAY xx,x[]
LIST.TOARRAY yy,y[]
Drawgraph(x[], y[], fields$[xfield], fields$[yfield],xdate )


array.length n,x[]
text.open w,h,"plot.txt"
text.writeln h,"plot"
text.writeln h,fields$[xfield]
text.writeln h,fields$[yfield]
for I=1 to n
text.writeln h,int$(x[I])+","+int$(y[I])
next
text.close h
EXIT
