! init display mode manager


BUNDLE.CREATE global %' 'global' bundle pointer = #1
BUNDLE.PUT global, "mode", "html"


! init display mode manager
FN.DEF dinit()
let s$="<html><body style=\"background-color:black\"></body></html>"
HTML.OPEN 0
html.load.string s$
bundle.put 1,"mode","html"
FN.END 


! change display mode to console,html or gr(aphics)
FN.DEF dmode(m$)
bundle.get 1,"mode",oldm$
 IF oldm$=m$ THEN FN.RTN 0
bundle.put 1,"mode",m$
 IF oldm$="html" then HTML.CLOSE
 IF oldm$="gr" then GR.CLOSE
 IF m$="html" THEN HTML.OPEN 0
 IF m$="gr" then GR.OPEN 255,0,0,0,0,1
 pause 300
FN.END


!read next record from open file handle h
! return 1 if EOF 

FN.DEF readrecord(h,a$,b$,c$)
 TEXT.READLN h,r$:text.eof h,e
 IF e THEN FN.RTN 1
 SPLIT s$[],r$,"\t"
 ARRAY.LENGTH l,s$[]
 IF l=3
  LET a$=s$[1]:LET b$=s$[2]:LET c$=s$[3]
 ENDIF
 FN.RTN 0
FN.END

! slightly more tolerant val function
FN.DEF val2(s$)
 let s$=TRIM$(s$):let l=len(s$)
 DO
  i++
  LET bad=!IS_IN(MID$(s$,i,1),"-0123456789.")
 UNTIL bad|i>=l
 IF !bad then FN.RTN VAL(s$)  
FN.RTN 0
FN.END

FN.DEF rset(s$) 
 ! PRE: s$ is setting name
 ! POST: RETURNs value of setting s$ or 0 if not found 
 LET F$="settings.ini"
 FILE.EXISTS e,f$ 
 IF !e THEN FN.RTN 0 
 GRABFILE b$,f$
 LET i=IS_IN(s$,b$)
 IF !i THEN FN.RTN 0
 LET t$=MID$(b$,i+LEN(s$),20)
 LET v$=TRIM$(WORD$(t$,1,CHR$(10)))
 IF v$="" THEN FN.RTN 0
 FN.RTN VAL2(v$)
FN.END


FN.DEF readln$(f$) 
 IF isold(f$)
  TEXT.OPEN r,h,f$
  TEXT.READLN h,a$
  TEXT.CLOSE h
 ELSE
  LET A$=""
 ENDIF
 FN.RTN a$
FN.END


FN.DEF isold(f$) 
 FILE.EXISTS o,f$ 
 FN.RTN o
FN.END

FN.DEF appendln(f$,m$) 
 TEXT.OPEN a,h,f$
 TEXT.WRITELN h,m$
 TEXT.CLOSE h
FN.END

FN.DEF writeln(f$,msg$) 
 TEXT.OPEN w,h,f$
 TEXT.WRITELN h,msg$
 TEXT.CLOSE h 
FN.END

FN.DEF wset(s$,v) 
 ! PRE: s$ is setting name,v is value to set 
 ! POST: setting named s$ is set to v
 LET F$="settings.ini"
 LET ns$=s$+"\t"+INT$(v)
 IF isold(f$)
  TEXT.OPEN r,h,f$
  LET o$=ns$+CHR$(10)
  DO
   TEXT.READLN h,a$
   IF a$="EOF" THEN D_U.BREAK
   IF !found & WORD$(a$,1,"\t")=s$
    LET found=1
   ELSE
    o$+=a$+CHR$(10)
   ENDIF
  UNTIL a$="EOF"
 ENDIF

 TEXT.CLOSE h

 CALL writeln(f$,TRIM$(o$))
FN.END


fn.def readsetting(s$)
fn.rtn rset(s$)
fn.end

fn.def writesetting(s$,v)
call wset(s$,v)
fn.end



! returns true if users answers yes to prompt m$
FN.DEF cask(m$)
 CALL dmode("console")
 DIALOG.MESSAGE,m$,c,"yes","no"
 IF c=1 THEN FN.RTN 1
 FN.RTN 0
FN.END


! from cclib.bas
!
!
! simple library functions 
! INCLUDE ccinit.lib

! save numerical bundle
FN.DEF nbsv(db$,b) 
 LET D$="\t"
 TEXT.OPEN w,f,db$
 BUNDLE.KEYS b,l
 LIST.SIZE l,z
 IF z<1 
  TEXT.WRITELN f,""
  TEXT.CLOSE f
  FN.RTN 0
 ENDIF
 LIST.TOARRAY l,ll$[] 
 ARRAY.SORT ll$[] 
 FOR i=1 TO z
  LET K$=ll$[i] 
  BUNDLE.GET b,k$,v
  IF k$<>""
   TEXT.WRITELN f,k$+d$+INT$(v) 
  ENDIF
 NEXT i
 TEXT.CLOSE f
FN.END

! load string bundle from file 
FN.DEF nbld(db$,b) 
 BUNDLE.CLEAR b
 LET D$="\t"
 FILE.EXISTS old,db$
 IF !old THEN FN.RTN 0
 TEXT.OPEN R,h,db$
 DO
  TEXT.READLN h,a$

  LET s1$=WORD$(a$,1,d$)
  LET s2$=WORD$(a$,2,d$)
  IF s1$<>""&S2$<>"" THEN BUNDLE.PUT b,s1$,VAL(s2$)
 UNTIL a$="EOF"
 TEXT.CLOSE h
FN.END




FN.DEF grab$(f$)
 IF isold(f$)
  GRABFILE s$,f$
  FN.RTN s$
 ELSE
  FN.RTN ""
 ENDIF
FN.END

! html format for calories
FN.DEF frmcal$(n) 
 LET i$=INT$(n)
 s$="&nbsp;&nbsp;&nbsp;&nbsp;"
 FN.RTN MID$(s$,1,6*(4-LEN(i$)))+i$
FN.END 


FN.DEF frm$(n,p)
if p=-1
 FN.RTN FORMAT$("####%.#",n)
else if p=-2
  FN.RTN FORMAT$("####%.##",n)
else if p=0
 FN.RTN FORMAT$("####%",n)
else
FN.RTN FORMAT$("####%.#",n)
endif
FN.END


FN.DEF getdate$()
 TIME Y$,M$,D$,H$,Mi$,S$,WkD,DST
 LET Dd$=m$+"-"+d$+"-"+y$
 FN.RTN dd$
FN.END

FN.DEF Asklist2$(p,msg$,r)
 ! PRE: string list p
 !       msg$ is prompt to display
 ! POST: r=index of item in p chosen
 !     Returns  string of item
 !
 DO
  LET I$=""
  DIALOG.SELECT r,p,msg$
  IF r>0
   LIST.GET p,r,i$
  ENDIF
 UNTIL r>0
 FN.RTN TRIM$(i$)
FN.END



FN.DEF editor(f$,p$) 
 r$=CHR$(10)
 ue$=grab$(f$)
 ue$=TRIM$(ue$)+r$
 TEXT.INPUT e$,ue$,p$
 IF !editcancel then call writeln(f$,e$)

FN.END

FN.DEF INPUTNUMBER(s$,d)
 PAUSE 100
 KB.HIDE
 PAUSE 1000
 ?
 KB.TOGGLE
 IF d>=0
  INPUT s$,v,d,c
 ELSE
  INPUT s$,v,,c
 ENDIF
 IF c THEN EXIT 
 FN.RTN v
FN.END 



FN.DEF isadigit(s$) 
 FN.RTN IS_IN(s$,"-0123456789.")
FN.END

FN.DEF hasdigits(s$) 
 LET I=1
 LET Found=0
let l=len(s$)
 DO
 let found=isadigit(MID$(s$,I,1))
  I++
 UNTIL i>l|found
 FN.RTN found
FN.END


! extract number from s$
FN.DEF readnumber(s$) 
 LET N$=""
 FOR i=1 TO LEN(s$) 
  LET C$=MID$(s$,I,1)
  IF isadigit(c$) THEN N$+=c$
 NEXT i
 IF LEN(n$)>0 THEN FN.RTN VAL(n$) 
 FN.RTN 0
FN.END

! val that returns 0 if not valid
! returns s$ with all numbers removed
FN.DEF stripdigits$(s$) 
 LET N$=""
 FOR i=1 TO LEN(s$) 
  LET C$=MID$(s$,I,1)
  IF !isadigit(c$) THEN N$+=c$
 NEXT i 
 IF LEN(n$)>0 THEN FN.RTN n$
 FN.RTN "" 
FN.END

FN.DEF waitclick$()
 DO
  PAUSE 100
  HTML.GET.DATALINK data$
  IF BACKGROUND() 
cs=clock()
do
pause 100
until (clock()-cs)>5000|!background()
if background() then EXIT
endif
 UNTIL data$ <> ""
 ! popup data$,0,0,0
 IF IS_IN("BAK:",data$)=1
  EXIT
 ELSEIF IS_IN("DAT:",data$)=1
  data$=MID$(data$,5) %' User link
 ELSEIF IS_IN("LNK:file:///",data$)=1&IS_IN("?",data$) %' Submit link
  i=IS_IN("?",data$)
  data$="SUBMIT&"+MID$(data$,i+1)+"&"
 ENDIF
 FN.RTN data$
FN.END




FN.DEF asklist$(l,msg$,c)
 r$="<br>"
h$="<!DOCTYPE html><html lang=~en~>"
h$+="<h1 style=~color:#999999~>"+msg$ +"</h1>"
 h$+="<body style=~background-color:#000000; text-align:center;~>"

 
 LIST.SIZE l,z

 h$+="<div>"

 FOR i=1 TO z
  LIST.GET l,i,s$
  s$=REPLACE$(s$,"'","&apos;")
  but$="<button type=~button~  style=~background-color:#333333;color:#FFFFFF;text-align:center;font-size:20px;width:300px;height:50px;~ onclick=~doDataLink('"+STR$(i)+"')~;>"+s$+"</button><br>"
  h$+=but$
 NEXT i
 h$+="</div>"
 h$+="<script type=~text/javascript~>"
 h$+="function doDataLink(data) "
 h$+="{Android.dataLink(data);}</script>"
 h$+="</body>"
 h$+="</html>"
 h$=REPLACE$(h$,"~","\"")
dmode("html")
 HTML.LOAD.STRING h$
do
 r$=waitclick$()
 c=readnumber(r$)
until c>0
 !popup r$
 LIST.GET l,c,s$

 FN.RTN s$
FN.END
fn.def askyn(p$)
list.create s,m
list.add m,"yes","no"
c=0
call asklist$(m,p$,&c)
list.clear m
if c=1 then fn.rtn 1
fn.rtn 0
fn.end




FN.DEF bkhit()
let b=0
 IF readln$("back.txt")="1"
  let b=1
  POPUP "back key hit"
  call writeln("back.txt","0")
 ENDIF
 FN.RTN b

FN.END



! 
!
! from ccedit.bas
!

!include ccmode.bas
!include cclib.bas

FN.DEF htmledit$(p$,s$) 
 dmode("html")
 w$="<html>"
 w$+="<head >"
 w$+="<meta http-equiv=\"content-type\" content=\"text/html;charset=UTF-8\"/>"
 w$+="<title >edit text</title>"
 w$+="</head>"
 w$+="<script type=\"text/javascript\">"
 w$+="function doDataLink(data) {"
 w$+="Android.dataLink(data);"
 w$+="}"
 w$+="</script>"
 w$+="<body bgcolor=\"black\" >"
 w$+="<div align=\"left\">"
 w$+="<h2 style=\"color:#999999\">###prompt</h2>"
 w$+=""
 w$+="<form id='main' method='get' action='FORM'>"
 w$+="<input type='submit' style=\"float:left;\" name='submit' value='Done'/>"
 w$+="<TEXTAREA NAME=\"id\"  ROWS=35 COLS=30 style=\"font-size:16px;\" >"
 w$+="###edit"
 w$+="</TEXTAREA>"
 w$+="</form>"
 w$+="</div>"
 w$+="<br><br><br><br><br><br>"
w$+="<br><br><br><br><br><br>"
 w$+="</body>"
 w$+="</html>"

 w$ =REPLACE$(w$,"###prompt",p$)
 w$ = REPLACE$(w$,"###edit", TRIM$(s$))
 HTML.LOAD.STRING w$
 HTML.LOAD.URL "javascript:DODataLink(document.getElementById('id'))h
 r$=waitclick$()
 ! popup "please wait..."
 s$= DECODE$("URL","UTF-8",r$)
 s$=REPLACE$(s$,"SUBMIT&submit=Done&id=","")
 s$=LEFT$(s$,LEN(s$)-1)

 FN.RTN s$
FN.END 








